# SourcePath: perf/20110607dev
Summary: A system-wide profile and per application profiler.
Name: sony-target-devtool-perf
%define pkgname_perfmini %{sony_tool_triplet}-%{sony_target_dialect}-devtool-perf-mini
%define pkgname_perf %{sony_tool_triplet}-%{sony_target_dialect}-devtool-perf
Version: 1.0.0
Release: 08010201
Source0: perf-%{version}.tar.gz
Patch0: perf-%{version}-include-headers-fix.patch
Patch1: perf-%{version}-makefile-fix.patch 
Patch2: perf-%{version}-add-rbtree.patch 
Patch3: perf-%{version}-python-support.patch
Patch4: perf-%{version}-help-fix.patch
Patch5: perf-%{version}-archive-fix.patch
Patch6: perf-%{version}-builtin-builid-list-fix-20111123.patch
Patch7: perf-%{version}-symbols-remove-incorrect-open-coded-add-container_of-20110826.patch
Patch8: perf-%{version}-cross-compile-fix.patch
Patch9: perf-%{version}-probe-mount-fix-20111208.patch
License: GPL2
URL:http://kernel.org
Group: %{sony_group}
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_target_dir}

%description
The performance counter subsystem is a system wide profiler. With 
performance counter subsystem, the profile of system including user-space 
and every individual application can be obtained.
Performance counter subsystem consists of 

%package -n %{pkgname_perfmini}
Summary: A system-wide peformance counter profiler.
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname_perfmini}
The performance counter subsystem is a system wide profiler. With 
performance counter subsystem, the profile of system including user-space 
and every individual application can be obtained. Unsupported for perl and python scripts.

%package -n %{pkgname_perf}
Summary: A system-wide peformance counter profiler.
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname_perf}
The performance counter subsystem is a system wide profiler. With 
performance counter subsystem, the profile of system including user-space 
and every individual application can be obtained.
Performance counter subsystem consists of 
	Performance counter module
	Perf tool
Performance counter is supported on AMD models and Core2 / Corei7 / Atom 
Intel CPUs - both 64-bit and 32-bit architectures.If performance counter 
kernel is booted on supported CPU ,then profiling can be done by recording 
samples into local files and analyzing the profile samples using 'perf'tool.
The performance counter profiles software and hardware events.It is different 
from oprofile as performance counter provides the number of context-switches,
number of page-faults occurred per application during profiling of samples.

%prep
%setup  -q -n perf-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p3

#
%build
rm -rf %{buildroot}
%{sony_target_dev_setup}
%demangle_XXX_config
# build perf mini [disable python]
make ARCH=arm KERNEL_BUILD_PATH=/usr/local/%{sony_tool_triplet}/kbuild EXTRA_CFLAGS=-D__arm__ NO_LIBPYTHON=0
cp -r perf perf_mini
cp -r perf-archive perf_mini-archive
make clean

#
%install
%{sony_target_dev_setup} 
rm -rf %{buildroot}
mkdir -p  %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
install -m 755 perf_mini %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
install -m 755 perf_mini-archive %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
# build and install perf [with python support]
make ARCH=arm prefix=%{sony_target_devtool_prefix} KERNEL_BUILD_PATH=/usr/local/%{sony_tool_triplet}/kbuild EXTRA_CFLAGS="-D__arm__ -I%{sony_target_dir}%{sony_target_devtool_include_dir}/python2.6 " PYTHON_EMBED_LDFLAGS="-lpthread -ldl -lutil -lm -lpython2.6" DESTDIR=%{buildroot}%{sony_target_dir} install
install -m 755 perf-archive %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}

# Remove unsupported perl scripts
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_devtool_libexec_dir}/perf-core/scripts/perl

#
%clean
rm -rf %{buildroot}

%files -n %{pkgname_perfmini}
%defattr(-,root,root,-)
%{sony_target_dir}%{sony_target_devtool_bin_dir}/perf_mini
%{sony_target_dir}%{sony_target_devtool_bin_dir}/perf_mini-archive

%files -n %{pkgname_perf}
%defattr(-,root,root,-)
%{sony_target_dir}%{sony_target_devtool_bin_dir}/perf
%{sony_target_dir}%{sony_target_devtool_bin_dir}/perf-archive
%{sony_target_dir}%{sony_target_devtool_libexec_dir}/


%changelog
* Tue Feb 07 2012 Sony Corporation
- Added Fix for probe mount.

* Mon Nov 28 2011 Sony Corporation
- Fixed cross compilation error for ARM.
- Fixed perf probe and perf buildid commands.

* Fri Sep 16 2011 Sony Corporation
 - Refreshed perf-help fix patch 

* Thu Sep 15 2011 Sony Corporation
 - Added archive fix patch for perf

* Tue Aug 02 2011 Sony Corporation
 - Added help fix patch for perf

* Mon Jul 25 2011 Sony Corporation
 - Added support for perf-archive

* Thu Jul 21 2011 Sony Corporation
 - Added support for perf-mini
 - Added support of python scripts

* Mon Jun 07 2011 Sony Corporation
- Initial version
